#include "./ESP8266/bsp_esp8266.h"
#include "./Common/common.h"
#include <stdio.h>  
#include <string.h>  
#include <stdbool.h>
#include "./SysTick/bsp_SysTick.h"



static void     ESP8266_GPIO_Config                 ( void );
static void     ESP8266_USART_Config                ( void );
static void     ESP8266_USART_NVIC_Configuration    ( void );

struct  STRUCT_USARTx_Fram strEsp8266_Fram_Record = { 0 };

//ESP8266ʼ
void ESP8266_Init()
{
	//ȳʼCH-PDRSTܽPB13,14
	ESP8266_GPIO_Config();
	//ESP8266
	ESP8266_USART_Config ();
	//ͨWiFiʹܹ
	//RST͵ƽЧ
	GPIO_SetBits(GPIOG,GPIO_Pin_14);
	//CH-PDߵƽЧ
	GPIO_ResetBits(GPIOG,GPIO_Pin_13);
}

static void ESP8266_GPIO_Config()
{
	//ʱRCC
	//ṹ
	GPIO_InitTypeDef GPIO_InitStructure;
	
	//CH-pd
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOG,&GPIO_InitStructure);
	
	//RST
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_14;
    GPIO_Init(GPIOG,&GPIO_InitStructure);
}

static void ESP8266_USART_Config ( void )
{
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_InitTypeDef USART_InitStructure;
	
	
	/* config USART clock */
	macESP8266_USART_APBxClock_FUN ( macESP8266_USART_CLK, ENABLE );
	macESP8266_USART_GPIO_APBxClock_FUN ( macESP8266_USART_GPIO_CLK, ENABLE );
	
	/* USART GPIO config */
	/* Configure USART Tx as alternate function push-pull */
	GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);  
  
	/* Configure USART Rx as input floating */
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	/* USART3 mode config */
	USART_InitStructure.USART_BaudRate = 115200;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART3, &USART_InitStructure);
	
		/* ж */
	USART_ITConfig ( USART3, USART_IT_RXNE, ENABLE ); //ʹܴڽж 
	USART_ITConfig ( USART3, USART_IT_IDLE, ENABLE ); //ʹܴ߿ж 	

	ESP8266_USART_NVIC_Configuration ();
	
	USART_Cmd(USART3, ENABLE);
	
}

// ESP8266  USART3NIVCж
static void ESP8266_USART_NVIC_Configuration ( void )
{
	NVIC_InitTypeDef NVIC_InitStructure; 
	
	//κεNVICӦͨжϣҪ, 趨飬ʵ趨ռȼλ
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	/* Enable the USART2 Interrupt */
	NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;	 
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);	
}
  
void ESP8266_AT_Test (void)
{
	 char count =0;
	 //RSTߵƽ
	macESP8266_RST_HIGH_LEVEL();	
	//GPIO_SetBits(GPIOG,GPIO_Pin_14);
	Delay_ms ( 1000 );
	while(count<10)
	{
		//ڷָESP8266Cmdbsp_esp8266.cļж壬 ʵִ3ʽسЩת16ƣֱַo okWiFiӦֵжϣNULLڴ
		//reply1reply2ڴӦ
		//OKдokstrstrԴСд𣬸úԴСдСдСдеʹ stristr()
		if(  ESP8266_Cmd ( "AT", "OK", NULL, 500 )  )
			return;
		//оWiFiWiFiAT+RSTָ ʹRST
		ESP8266_Rst();
		++ count;
	}
}

/*
 * ESP8266_Rst
 *   WF-ESP8266ģ
 *   
 *   : 
 *    ESP8266_AT_Test 
 */
void ESP8266_Rst ( void )
{
	// ͡/* */һһǣһǶףԤڶʱ԰ѡ#if 0ĳɡ#if 1ȡĳδġΡ׿Խԣ׾ġ/* */ɣΨһȱڱ༭ûСע͡еıʾʽ
	#if 0
	 ESP8266_Cmd ( "AT+RST", "OK", "ready", 2500 );   	
	
	#else
	 macESP8266_RST_LOW_LEVEL();
	 Delay_ms ( 500 ); 
	 macESP8266_RST_HIGH_LEVEL();
	 
	#endif
}

/*
 * ESP8266_Cmd
 *   WF-ESP8266ģ鷢ATָ
 *   cmd͵ָ
 *         reply1reply2ڴӦΪNULLӦΪ߼ϵ
 *         waittimeȴӦʱ
 *   : 1ָͳɹ
 *         0ָʧ
 *   ⲿ
 */
bool ESP8266_Cmd ( char * cmd, char * reply1, char * reply2, u32 waittime )
{    
	strEsp8266_Fram_Record.InfBit.FramLength = 0; //¿ʼµݰ

	printf( "%s\r\n", cmd );
	//3 
	macESP8266_Usart ( "%s\r\n", cmd );
    
	
	if ( ( reply1 == 0 ) && ( reply2 == 0 ) )   //Ҫ
		return true;
	
	Delay_ms ( waittime );                 //ʱ,ǲWiFiӵָ֮󣬶ٺӦӶжϽղ̫Ҳû
	
	strEsp8266_Fram_Record.Data_RX_BUF[ strEsp8266_Fram_Record .InfBit .FramLength ]  = '\0';
	//printf
	macPC_Usart ( "%s", strEsp8266_Fram_Record.Data_RX_BUF );
  
	if ( ( reply1 != 0 ) && ( reply2 != 0 ) )
		return ( ( bool ) strstr ( strEsp8266_Fram_Record .Data_RX_BUF, reply1 ) || 
						 ( bool ) strstr ( strEsp8266_Fram_Record .Data_RX_BUF, reply2 ) ); 
 	
	else if ( reply1 != 0 )
		return ( ( bool ) strstr ( strEsp8266_Fram_Record .Data_RX_BUF, reply1 ) );
	
	else
		return ( ( bool ) strstr ( strEsp8266_Fram_Record .Data_RX_BUF, reply2 ) );
	
}


/*
 * ESP8266_Net_Mode_Choose
 *   ѡWF-ESP8266ģĹģʽ
 *   enumModeģʽ
 *   : 1ѡɹ
 *         0ѡʧ
 *   ⲿ
 */
bool ESP8266_Net_Mode_Choose ( ENUM_Net_ModeTypeDef enumMode )
{
	switch ( enumMode )
	{
		case STA:
			return ESP8266_Cmd ( "AT+CWMODE=1", "OK", "no change", 2500 ); 
		
	  case AP:
		  return ESP8266_Cmd ( "AT+CWMODE=2", "OK", "no change", 2500 ); 
		
		case STA_AP:
		  return ESP8266_Cmd ( "AT+CWMODE=3", "OK", "no change", 2500 ); 
		
	  default:
		  return false;
  }
	
}
/*
 * ESP8266_CIPAP
 *   ģ AP IP
 *   pApIpģ AP IP
 *   : 1óɹ
 *         0ʧ
 *   ⲿ
 */
uint8_t ESP8266_CIPAP ( char * pApIp )
{
	char cCmd [ 30 ];
		
	
	sprintf ( cCmd, "AT+CIPAP=\"%s\"", pApIp );
	
  if ( ESP8266_Cmd ( cCmd, "OK", 0, 5000 ) )
		return 1;
 
	else 
		return 0;
	
}
/*
 * ESP8266_BuildAP
 *   WF-ESP8266ģ鴴WiFiȵ
 *   pSSIDWiFiַ
 *       pPassWordWiFiַ
 *       enunPsdModeWiFiܷʽַ
 *   : 1ɹ
 *         0ʧ
 *   ⲿ
 */
bool ESP8266_BuildAP ( char * pSSID, char * pPassWord, ENUM_AP_PsdMode_TypeDef enunPsdMode )
{
	char cCmd [120];

	sprintf ( cCmd, "AT+CWSAP=\"%s\",\"%s\",1,%d", pSSID, pPassWord, enunPsdMode );
	
	return ESP8266_Cmd ( cCmd, "OK", 0, 1000 );
	
}
/*
 * ESP8266_Enable_MultipleId
 *   WF-ESP8266ģ
 *   enumEnUnvarnishTxǷ
 *   : 1óɹ
 *         0ʧ
 *   ⲿ
 */
bool ESP8266_Enable_MultipleId ( FunctionalState enumEnUnvarnishTx )
{
	char cStr [20];
	
	sprintf ( cStr, "AT+CIPMUX=%d", ( enumEnUnvarnishTx ? 1 : 0 ) );
	
	return ESP8266_Cmd ( cStr, "OK", 0, 500 );
	
}

/*
 * ESP8266_StartOrShutServer
 *   WF-ESP8266ģ鿪رշģʽ
 *   enumMode/ر
 *       pPortNum˿ںַ
 *       pTimeOverʱʱַλ
 *   : 1ɹ
 *         0ʧ
 *   ⲿ
 */
bool ESP8266_StartOrShutServer ( FunctionalState enumMode, char * pPortNum, char * pTimeOver )
{
	char cCmd1 [120], cCmd2 [120];

	if ( enumMode )
	{
		sprintf ( cCmd1, "AT+CIPSERVER=%d,%s", 1, pPortNum );
		
		sprintf ( cCmd2, "AT+CIPSTO=%s", pTimeOver );

		return ( ESP8266_Cmd ( cCmd1, "OK", 0, 500 ) &&
						 ESP8266_Cmd ( cCmd2, "OK", 0, 500 ) );
	}
	
	else
	{
		sprintf ( cCmd1, "AT+CIPSERVER=%d,%s", 0, pPortNum );

		return ESP8266_Cmd ( cCmd1, "OK", 0, 500 );
	}
	
}

/*
 * ESP8266_Inquire_ApIp
 *   ȡ F-ESP8266  AP IP
 *   pApIp AP IP ׵ַ
 *         ucArrayLength AP IP ĳ
 *   : 0ȡʧ
 *         1ȡɹ
 *   ⲿ
 */
uint8_t ESP8266_Inquire_ApIp ( char * pApIp, uint8_t ucArrayLength )
{
	char uc;
	
	char * pCh;
	
	
  ESP8266_Cmd ( "AT+CIFSR", "OK", 0, 500 );
	
	pCh = strstr ( strEsp8266_Fram_Record .Data_RX_BUF, "APIP,\"" );
	
	if ( pCh )
		pCh += 6;
	
	else
		return 0;
	
	for ( uc = 0; uc < ucArrayLength; uc ++ )
	{
		pApIp [ uc ] = * ( pCh + uc);
		
		if ( pApIp [ uc ] == '\"' )
		{
			pApIp [ uc ] = '\0';
			break;
		}		
	}	
	return 1;
}

/*
 * ESP8266_SendString
 *   WF-ESP8266ģ鷢ַ
 *   enumEnUnvarnishTxǷʹ͸ģʽ
 *       pStrҪ͵ַ
 *       ulStrLengthҪ͵ַֽ
 *       ucIdĸID͵ַ
 *   : 1ͳɹ
 *         0ʧ
 *   ⲿ
 */
bool ESP8266_SendString ( FunctionalState enumEnUnvarnishTx, char * pStr, u32 ulStrLength, ENUM_ID_NO_TypeDef ucId )
{
	char cStr [20];
	bool bRet = false;
	
		
	if ( enumEnUnvarnishTx )
	{
		macESP8266_Usart ( "%s", pStr );
		
		bRet = true;
		
	}

	else
	{
		if ( ucId < 5 )
			sprintf ( cStr, "AT+CIPSEND=%d,%d", ucId, ulStrLength + 2 );

		else
			sprintf ( cStr, "AT+CIPSEND=%d", ulStrLength + 2 );
		
		ESP8266_Cmd ( cStr, "> ", 0, 100 );

		bRet = ESP8266_Cmd ( pStr, "SEND OK", 0, 500 );
  }
	
	return bRet;

}


/*
 * ESP8266_UnvarnishSend
 *   WF-ESP8266ģ͸
 *   
 *   : 1óɹ
 *         0ʧ
 *   ⲿ
 */
bool ESP8266_UnvarnishSend ( void )
{
	if ( ! ESP8266_Cmd ( "AT+CIPMODE=1", "OK", 0, 500 ) )
		return false;
	
	return 
	  ESP8266_Cmd ( "AT+CIPSEND", "OK", ">", 500 );
	
}
//ѯʹģʽ
uint8_t ESP8266_Inquire_mode(char * modestr,uint8_t length)
{
	char len;
	char * pCh;
	ESP8266_Cmd("AT+CIPMODE?","OK",0,500);
	printf("wifiʲôң%s",strEsp8266_Fram_Record .Data_RX_BUF);
	
	pCh = strstr ( strEsp8266_Fram_Record.Data_RX_BUF, "CIPMODE:" );
	
	if(pCh)
	{
		pCh +=8;
	}
	else return 0;
	
	for( len=0; len < length; len++)
	{
		modestr[len] = *( pCh +len);
		if(modestr[len] == '\"')
		{
			modestr[len] = '\0';
			break;
		}
	}
	return 1;

}




